

// Copyright: Hans de Nivelle, May 2005. 


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >



#include "groundatom.h"


std::ostream& operator << ( std::ostream& stream,
		            const groundatom& at )
{
   if( at. p == predicate::create )
   {
      stream << at. p << " " << *at. a1;
      return stream;
   }

   if( at. p == predicate::diseq )
   {
      stream << *at. a1 << " " << at. p << " " << * ( at. a1 + 1 );
      return stream;
   }

   stream << at. p;
   if( at. a2 - at. a1 > 0 )
   {
      stream << "(";
      for( std::vector< element > :: const_iterator e = at. a1; 
	   e != at. a2; 
	   ++ e )
      {
         stream << *e;
	 if( e != at. a2 - 1 )
            stream << ",";
      }
      stream << ")";
   }

   return stream;
}


bool operator == ( const groundatom& g1, const groundatom& g2 )
{
   if( g1.p != g2.p )
      return false;
   else
   {
      std::vector< element > :: const_iterator x1 = g1. a1;
      std::vector< element > :: const_iterator x2 = g2. a1;
      while( x1 != g1. a2 )
      {
         if( *x1 != *x2 )
            return false;

	 ++ x1;
	 ++ x2;
      }
   }
   return true;
}


