

// Copyright: Hans de Nivelle


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >



#include "statistics_collector.h"


namespace swll
{

   std::ostream& operator << ( std::ostream& stream,
		               const statistics_collector& sc )
   {
      stream << "-------------------------------\n";
      stream << "nr_calls = " << sc. nr_calls << "\n";

      stream << "passed set problem = ";
      stream << sc. nr_passedsetproblem << "\n";

      stream << "nr solution = " << sc. nr_solution << "\n";

      stream << "max_lemmas = " << sc. max_lemmas << "\n"; 
      stream << "max_size = " << sc. max_size << "\n"; 

      if( sc. nr_calls )
      {
         stream << "average lemmas = ";
	 stream << sc. sum_lemmas / sc. nr_calls << "\n";
	 stream << "average size = "; 
	 stream << sc. sum_size / sc. nr_calls << "\n";
      }
      stream << "-------------------------------\n";

      return stream; 
   } 

} 



