

// Copyright: Hans de Nivelle, April 2006.


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >


#include "valueset.h"


namespace swll
{

   valueset::valueset( )
   {
   }


   valueset::valueset( unsigned int x )
      : repr( std::vector< member > ( 1 + x ))
   {
   }


   void valueset::clear( )
   {
      repr. clear( );
   }


   void valueset::unmarkall( )
   {
      for( std::vector< member > :: iterator 
              p = repr. begin( );
	      p != repr. end( );
	      ++ p )
      {
         ( p -> marked ) = false;
      }
   }


   bool valueset::restricttomarked( ) 
   {
      bool deleted = false;

      for( std::vector< member > :: iterator
              p = repr. begin( );
	      p != repr. end( );
	      ++ p )
      {
         if( p -> contained )
         {
            if( ! p -> marked )
            {
               deleted = true;
	       p -> contained = false;
	    }
	    else
            {
	       p -> marked = false;
            }
         }
      }
      return deleted;
   }

   
   std::ostream& operator << ( std::ostream& stream, 
		               const valueset& s )
   {
      unsigned int cnt = 0;

      stream << "valueset{ ";
      unsigned int i = 0; 
      for( auto
              p = s. repr. begin( );
	      p != s. repr. end( );
	      ++ p, ++ i )
      {
         if( p -> contained )
         {
            if( cnt != 0 )
               stream << ", ";
	    stream << i;
	    if( p -> marked )
               stream << "*";

	    ++ cnt;
         }
      }
      stream << " }";
      return stream;
   }

} 


