

// Copyright: Hans de Nivelle, April 2006.


// This file is part of Geo2007F.
//
// Geo 2007F is free software: You can distribute it and/or modify
// it under the terms of the GNU General Public License, Version 3,
// as published by the Free Software Foundation.
//
// Geo2007F is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// Version 3 along with Geo2007F. It not, see 
// < http://www.gnu.org/licenses/ >



#include "vardata.h"


namespace swll
{

   void vardata::clear( )
   {
      repr. clear( );
   }


   const vardata::data & vardata::operator [] ( variable v ) const
   {
      unsigned int k = v. getunsigned( );
      ASSERT( k < repr. size( ));
      return repr [k];
   }


   vardata::data & vardata::operator [] ( variable v ) 
   {
      unsigned int k = v. getunsigned( );
      if( k >= repr. size( ))
      {
         repr. insert( repr. end( ), 1 + k - repr. size( ),
		       vardata::data( ) ); 
	    // Expand the vector. 
      }
      return repr [k];
   }


   std::ostream& operator << ( std::ostream& stream,
		               const vardata& vd )
   {
      stream << "vardata:\n"; 
      for( unsigned int v = 0; v < vd. repr. size( ); ++ v )
      {
         if( vd. repr [v]. occurrences. size( ))
         {
            std::cout << variable::constructfromunsigned(v) << "   ";
            stream << "[" << vd. repr [v]. lastupdate << "] : ";
            stream << vd. repr [v]. possiblevalues;
	    stream << " occurrences[ "; 
	    for( std::vector< unsigned int > :: const_iterator
                    p = vd. repr [v]. occurrences. begin( );
		    p != vd. repr [v]. occurrences. end( );
		    ++ p )
            {
               if( p != vd. repr [v]. occurrences. begin( )) 
                  stream << ", "; 
               stream << *p;
            }
	    stream << " ]"; 
	    stream << "\n";
         }
      }
      return stream; 
   }

} 



